#include <iostream>

struct Pacijent {
    int a[4];
};

Pacijent pacijenti[10000];

std::pair<int,int> kasnije[10000];
int n_kasnije = 0;

int main(){
    std::ios_base::sync_with_stdio(false);

    int N, zalihe[4];

    std::cin >> N >> zalihe[0] >> zalihe[1] >> zalihe[2] >> zalihe[3];

    bool nemoguce = false;

    for (int i = 0; i < N; i++){
        std::string tip;
        int potrebno;
        std::cin >> tip >> potrebno;

        int index;

        if (tip == "AB"){
            kasnije[n_kasnije].first = potrebno;
            kasnije[n_kasnije++].second = i;
            continue;
        }
        else if (tip == "B"){
            index = 2;
        }
        else if (tip == "A"){
            index = 1;
        }
        else if (tip == "O"){
            index = 0;
        }

        if (potrebno == 0) continue;

        if (index != 0){

            int transfer = std::min(zalihe[index], potrebno);

            potrebno -= transfer;
            zalihe[index] -= transfer;
            pacijenti[i].a[index] = transfer;

        }

        if (potrebno == 0) continue;

        int transfer = std::min(zalihe[0], potrebno);

        potrebno -= transfer;
        zalihe[0] -= transfer;
        pacijenti[i].a[0] = transfer;

        if (potrebno > 0){
            nemoguce = true;
            break;
        }

    }

    if (!nemoguce){
        for (int i = 0; i < n_kasnije; i++){
            if (kasnije[i].first == 0) continue;

            int transfer = std::min(zalihe[3], kasnije[i].first);

            kasnije[i].first -= transfer;
            zalihe[3] -= transfer;
            pacijenti[kasnije[i].second].a[3] = transfer;

            if (kasnije[i].first == 0) continue;

            transfer = std::min(zalihe[0], kasnije[i].first);

            kasnije[i].first -= transfer;
            zalihe[0] -= transfer;
            pacijenti[kasnije[i].second].a[0] = transfer;

            if (kasnije[i].first > 0){
                nemoguce = true;
                break;
            }
        }
    }

    if (nemoguce) std::cout << "nemoguce";
    else{
        std::cout << "moguce\n";
        for (int i = 0; i < N; i++){
            for (int j = 0; j < 4; j++) std::cout << pacijenti[i].a[j] << " ";
            std::cout << "\n";
        }
    }

    return 0;
}